#ifndef TWN_WORKERS_C_H
#define TWN_WORKERS_C_H

#include <SDL2/SDL.h>

#include <stdbool.h>

#define MAX_WORKERS 9

/* workers are waiting on this, increment this value when some work needs to be done */
/* for now every possible job path is hardcoded in twn_workers.c itself */
extern SDL_sem *workers_job_semaphore;

bool workers_init(size_t worker_count);
void workers_deinit(void);

#endif
